
/*----------[ Dosierpumpe Version 4.12 )----------
             
    Softwareversion 9.12 | Copyright 2016
             By Stefan Schepperle
            stefan@schepperle.info

-----------[ ATMega 328      [Arduino] )----------*/


/*-----[ Programm neu Starten und in Loop zurück springen )-----*/
void Start(unsigned int Startscreen){
 switch (Startscreen){
case 1:
  lcd.clear();
  if(hour() < 10){ // wenn kleiner 10 schreibe eine 0 davor
  lcd.setCursor(0,0);lcd.print("0");pause_hour=1;}
  else pause_hour = 0;
  
  if(minute() < 10){ // wenn kleiner 10 schreibe eine 0 davor
  lcd.setCursor(3,0);lcd.print("0");pause_min=4;}
  else pause_min = 3;
  
  lcd.setCursor(pause_hour,0); //Start at character 4 on line 0
  lcd.print(hour());lcd.print(":");
  lcd.setCursor(pause_min,0); //Start at character 4 on line 0
  lcd.print(minute());
  lcd.setCursor(11,0); //Start at character 4 on line 0
  lcd.print(day());lcd.print(".");lcd.print(month());lcd.print(".");lcd.print(year());

  lcd.setCursor(0,1);
  lcd.print("--------------------");
  lcd.setCursor(2,2);
  lcd.print("Dosierpumpe v.4.12");
  lcd.setCursor(0,3);
  lcd.print("[~]Setup     [o]Info");
  loop;
break;
}}

/*-----[ Übersich darstellen )-----*/
void uebersicht(unsigned int Menuepunkt){
 switch (Menuepunkt){
case 1:
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("Uebersicht");
  lcd.setCursor(0,1); lcd.print("Pumpe1:"); lcd.setCursor(8,1); lcd.print(pumpe1_ml); lcd.setCursor(10,1); lcd.print("ml"); lcd.setCursor(14,1); lcd.print(pumpe1_time_h);lcd.setCursor(16,1); lcd.print(":"); lcd.setCursor(17,1); lcd.print(pumpe1_time_m);
  lcd.setCursor(0,2); lcd.print("Pumpe2:"); lcd.setCursor(8,2); lcd.print(pumpe2_ml); lcd.setCursor(10,2); lcd.print("ml"); lcd.setCursor(14,2); lcd.print(pumpe2_time_h);lcd.setCursor(16,2); lcd.print(":"); lcd.setCursor(17,2); lcd.print(pumpe2_time_m);
  lcd.setCursor(0,3); lcd.print("Pumpe3:"); lcd.setCursor(8,3); lcd.print(pumpe3_ml); lcd.setCursor(10,3); lcd.print("ml"); lcd.setCursor(14,3); lcd.print(pumpe3_time_h);lcd.setCursor(16,3); lcd.print(":"); lcd.setCursor(17,3); lcd.print(pumpe3_time_m);
  delay (5000);
  Start(1); 
break;
}}

/*-----[ Reset ausführung )-----*/
void Reset(unsigned int Resetten){
 switch (Resetten){
case 1: // alles aus
  {asm volatile ("  jmp 0"); }  
break;
}}

/*-----[ Uhrzeit und Datum speichern )-----*/
void timesaveave(unsigned int Timeset){
 switch (Timeset){
case 1:
setDS3231time(00,Min,Std, 3,  Tag,Mon,Jahr-48);  // Zeit und Datum werden Gespeichert
Reset(1);  
}}

/*-----[ Dosiermenge je Pumpe speichern )-----*/
void mengesetzen(unsigned int MS){
 switch (MS){
case 1:
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("Menge      speichern");
  lcd.setCursor(0,1); lcd.print("--------------------");
  lcd.setCursor(0,2); lcd.print(String(" ") + String(pumpe1_ml) + String("ml   ") + String(pumpe2_ml) + String("ml   ") + String(pumpe3_ml) + String("ml")); 
  lcd.setCursor(0,3); lcd.print("[~]Zurueck   [o]Save"); 
  delay(2000);
  for (int i=0; i <= 255; i=0){
  if (digitalRead(tasterm)==HIGH) {EEPROM.write(0, pumpe1_ml); EEPROM.write(1, pumpe2_ml); EEPROM.write(2, pumpe3_ml); Reset(1);}
  if (digitalRead(tasterr)==HIGH) {Reset(1);}
}
}}

/*-----[ kallibrierung Speichern )-----*/
void kallisetzen(unsigned int kallset){
 switch (kallset){
case 1:
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("ml/s speichern");
  lcd.setCursor(0,1); lcd.print("--------------------");
  lcd.setCursor(0,2); lcd.print(String("0,") + String(pumpe1_ml_s) + String("ml ") +String("0,") + String(pumpe2_ml_s) + String("ml ") + String("0,") + String(pumpe3_ml_s) + String("ml")); 
  lcd.setCursor(0,3); lcd.print("[~]Zurueck   [o]Save"); 
  delay(2000);

for (int i=0; i <= 255; i=0){
  if (digitalRead(tasterm)==HIGH) {EEPROM.write(9, pumpe1_ml_s); EEPROM.write(10, pumpe2_ml_s); EEPROM.write(11, pumpe3_ml_s); Reset(1);}
  if (digitalRead(tasterr)==HIGH) {Reset(1);}
}
 }}
 
/*-----[ Uhrzeit der Dosierung speichern )-----*/
void pumptimesetzen(unsigned int PTS){
 switch (PTS){
case 1:
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("Pumpzeit     speichern");
  lcd.setCursor(0,1); lcd.print("--------------------");
  lcd.setCursor(0,2); lcd.print(String(pumpe1_time_h) + String(":") + String(pumpe1_time_m) +String("  ") + String(pumpe2_time_h) + String(":") + String(pumpe2_time_m) + String("  ") + String(pumpe3_time_h) + String(":") + String(pumpe3_time_m)); 
  lcd.setCursor(0,3); lcd.print("[~]Zurueck   [o]Save"); 
  delay(2000);
for (int i=0; i <= 255; i=0){
  
  if (digitalRead(tasterm)==HIGH) {EEPROM.write(3, pumpe1_time_h); EEPROM.write(4, pumpe2_time_h); EEPROM.write(5, pumpe3_time_h); EEPROM.write(6, pumpe1_time_m); EEPROM.write(7, pumpe2_time_m); EEPROM.write(8, pumpe3_time_m);Reset(1);}
  if (digitalRead(tasterr)==HIGH) {Reset(1);}
}

 
 }}
